#include <local_basic_type.h>
#include <string>   

/***************************************************************
struct`
***************************************************************/
//摜tf[^\
struct ImgAddDBAddData_st{
	std::string strFileName;				//t@C
	std::string strFolderPath;				//tH_pX
	uhword_type	uhwImgWidth;				//摜
	uhword_type	uhwImgHight;				//摜
	std::string strRobotIdentifier;			//{bgʎq
	uhword_type	uhwCameraNo;				//JNo
	double_type dLatitude;					//ܓx
	double_type dLongitude;					//ox
	double_type dAltitude;					//
	float_type	fdirection;					//p
	float_type	fPitchAngle;				//sb`p
	float_type	fRollAngle;					//[p
	std::string	strShootingTime;			//Be(ms)gp
	std::string strShootingPlanName;		//Bev於
};

//n}f[^\
struct MapDBAddInfo_st{
	uword_type uwTileNumX;					//X^C
	uword_type uwTileNumY;					//Y^C
	uword_type uwTileBaseCodeX;				//N_^CW
	uword_type uwTileBaseCodeY;				//I_^CW
	uword_type uwKeepZoomLevel;				//DB̃Y[xێ
};

//n}f[^\
struct MapDBAddData_st{
	std::string strTileName;				//^C
	std::string strFolderPath;				//tH_pX
	uword_type uwZoomLevel;					//Y[x
	uword_type uwTileCodeX;					//^CXW
	uword_type uwTileCodeY;					//^CYW
	double_type dStartLatitude;				//N_ܓx
	double_type dStartLongitude;			//N_ox
	double_type dEndLatitude;				//I_ܓx
	double_type dEndLongitude;				//I_ox
	std::string	strCreateDate;				//쐬
	std::string strSyntesisPlanName;		//v於
};

/***************************************************************
}N`
***************************************************************/
//================================================
//	
//================================================
//
#define	RESULT_SUCCESS						0				//sOK
#define	RESULT_ERROR						1				//sNG
#define	RESULT_WARNING						2				//x

//gC֘A
#define	RETRY_MAX_NUM						10				//gC
#define	RETRY_WAIT_TIME						500				//gCwait

//tH_pX
#define	STRING_BUFF_MAX_SIZE				256				//stringi[̈̃TCY
#define	FOLDER_PATH_INIT					("")			//l
#define	ROBOT_BASE_FOLDER_PATH		("c:/DBRelateData/RobotData/")	//tf[^BaseAhX
#define	ROBOT_BASE_PATH_LENGTH				26				//tf[^BaseAhXf[^
#define	ADDITIONAL_DATA_FOLDER		("Additional data/")	//{bgBetf[^tH_
#define	PICTURE_FOLDER				("Picture/")			//{bgBe摜f[^tH_
#define	MAP_BASE_FOLDER_PATH		("c:/DBRelateData/MapData/")	//n}f[^BaseAhX
#define	MAP_BASE_PATH_LENGTH				24				//n}f[^BaseAhXf[^
#define	TILE_FOLDER					("Tile/")				//n}f[^̃^CtH_
#define	AP_FOLDER					("AerialPhotograph/")	//n}f[^̍qʐ^tH_
#define	MAP_TILE_FOLDER_PATH_LENGTH	(MAP_BASE_PATH_LENGTH + 5)	//n}f[^̃^CtH_AhXf[^

//{bgJeS[
#define	ROBOT_CATEGORY_DRONE				1				//h[
#define	ROBOT_CATEGORY_CRAWLER				2				//N[
#define	ROBOT_CATEGORY_GORONE				3				//S[
#define	ROBOT_CATEGORY_MAX					4				//MAX
#define	ROBOT_CATEGORY_INIT					0				//l

//v惊Xg
#define	GROUP_ID_NON						0				//v惊Xg̃O[vIDȂ
#define	PLAN_LIST_NUM_MAX					100				//v惊XgMAX

//f[^󂯓nptH_irtcԂŎ󂯓npngAjsont@CȂǂi[j
#define	TMP_FOLDER_PATH				"c:/workspace/tmp"		//TmptH_pX

//================================================
//	T[rX|[g֘A
//================================================
//T[rX|[g̗v󂯎
#define	RESULT_ACK							0				//v󂯎
#define	RESULT_NACK							1				//v󂯎Ȃ
#define	RESULT_BUSY							2				//쒆ŗv󂯎Ȃ

//vL
#define	SERV_REQ_CLEAR						0				//v
#define	SERV_REQ_SET						1				//vL

//ʒm
#define	NOTICE_INIT						0xFFFFFFFF			//ʒml
#define	NOTICE_PARAM_INIT				0xFFFFFFFF			//p[^l

//================================================
//	Maneger֘A
//================================================
//}l[WR|[lg̃f[^擾vT[rX|[gp[^
#define	MGR_REQ_NONE						0				//vȂ
#define	MGR_REQ_GET_PLAN_LIST				1				//BevAv惊Xg擾v
#define	MGR_REQ_GET_MAP_IMAGE				2				//n}摜擾v
#define	MGR_REQ_GET_CRAWLER_VIEW_IMAGE_RT	3				//Crawler ViewA^C摜擾v
#define	MGR_REQ_GET_CRAWLER_VIEW_IMAGE_DB	4				//Crawler View DB摜擾v
#define	MGR_REQ_MAX							5				//vMAX

//}l[WR|[lg̃Xe[^X񋟃T[rX|[gp[^
#define	MGR_MODE_INIT						0				//N
#define	MGR_MODE_ALL_LIST_READ				1				//SXgǂݍݒ
#define	MGR_MODE_IDLE						2				//ҋ@
#define	MGR_MODE_DB_REGISTRATION			3				//DBo^
#define	MGR_MODE_TILE_GENERATION			4				//^C
#define	MGR_MODE_DISP_READY					5				//\
#define	MGR_MODE_SYNTHE_LIST_DEL			6				//v惊Xg폜
#define	MGR_MODE_ERROR						7				//G[
#define	MGR_MODE_MAX						8				//MODE MAX

//}l[W슮ʒm			
#define	MGR_NOTICE_ALL_LIST_READ_SUCCESS	0				//SXgǂݍ݂ɐ܂
#define	MGR_NOTICE_ALL_LIST_READ_ERROR		1				//SXgǂݍ݂Ɏs܂
#define	MGR_NOTICE_DB_REGIST_SUCCESS		2				//DBo^ɐ܂
#define	MGR_NOTICE_DB_REGIST_ERROR			3				//DBo^Ɏs܂
#define	MGR_NOTICE_TILE_SPLIT_DISP_SUCCESS	4				//^CmFʕ\ɐ܂
#define	MGR_NOTICE_TILE_SPLIT_DISP_ERROR	5				//^CmFʕ\Ɏs܂
#define	MGR_NOTICE_SPLIT_DISP_ERASE_SUCCESS	6				//^CmFʏɐ܂
#define	MGR_NOTICE_SPLIT_DISP_ERASE_ERROR	7				//^CmFʏɎs܂
#define	MGR_NOTICE_TILE_GENERATE_SUCCESS	8				//^Cɐ܂
#define	MGR_NOTICE_TILE_GENERATE_ERROR		9				//^CɎs܂
#define	MGR_NOTICE_SYNTHE_LIST_DEL_SUCCESS	10				//v惊Xg폜ɐ܂
#define	MGR_NOTICE_SYNTHE_LIST_DEL_ERROR	11				//v惊Xg폜Ɏs܂
#define	MGR_NOTICE_IMAGE_DISP_SUCCESS		12				//ʍXVɐ܂
#define	MGR_NOTICE_IMAGE_DISP_ERROR			13				//ʍXVɎs܂
#define	MGR_NOTICE_MAIN_SCROLL_SUCCESS		14				//n}ʃXN[ɐ܂
#define	MGR_NOTICE_MAIN_SCROLL_ERROR		15				//n}ʃXN[Ɏs܂
#define	MGR_NOTICE_MAIN_ZOOMCHG_SUCCESS		16				//n}ʂ̃Y[x؂ւɐ܂
#define	MGR_NOTICE_MAIN_ZOOMCHG_ERROR		17				//n}ʂ̃Y[x؂ւɎs܂
#define	MGR_NOTICE_MAIN_MAPCHG_SUCCESS		18				//n}؂ւɐ܂
#define	MGR_NOTICE_MAIN_MAPCHG_ERROR		19				//n}؂ւɎs܂
#define	MGR_NOTICE_SUB_DISP_OFF_SUCCESS		20				//SUBOFFɐ܂
#define	MGR_NOTICE_SUB_SLIDE_SUCCESS		21				//Crawler ViewXCh؂ւɐ܂
#define	MGR_NOTICE_SUB_SLIDE_ERROR			22				//Crawler ViewXCh؂ւɎs܂
#define	MGR_NOTICE_INIT_WARNING				23				//N̂Key͖ł
#define	MGR_NOTICE_RUN_WARNING				24				//쒆̂Key͖ł
#define	MGR_NOTICE_ERROR					25				//G[̂Key͖ł
#define	MGR_NOTICE_MAX						26				//ʒmMAX

//================================================
//	@\֘A
//================================================
//ʎ
#define	OPE_SCREEN_MAIN						0				//Cʂ𑀍
#define	OPE_SCREEN_SUB						1				//Tuʂ𑀍
#define	OPE_SCREEN_MAX						2				//MAX
#define OPE_SCREEN_DEF					OPE_SCREEN_MAIN		//l

//SUBʕ\v
#define	SUB_SCREEN_OFF						0				//OFFI
#define	SUB_SCREEN_RT_IMAGE					1				//A^C摜I
#define	SUB_SCREEN_DB_IMAGE					2				//DB摜I
#define	SUB_SCREEN_MAX						3				//MAX
#define	SUB_SCREEN_VIEW_DEF				SUB_SCREEN_OFF		//l

//\L[			
#define	ARROW_OFF							0				//OFF
#define	ARROW_UP							1				//
#define	ARROW_DOWN							2				//
#define	ARROW_LEFT							3				//
#define	ARROW_RIGHT							4				//E
#define	ARROW_MAX							5				//MAX
#define	ARROW_DEF						ARROW_OFF			//l

//			
#define	DIRECTION_STEP_MIN					-180			//180
#define	DIRECTION_STEP_MID					0				//Z^[
#define	DIRECTION_STEP_MAX					180				//E180
#define	DIRECTION_STEP_DEF				DIRECTION_STEP_MID	//l

//XP[			
#define	SCALE_STEP_SMALL					0				//
#define	SCALE_STEP_MIDDLE					1				//
#define	SCALE_STEP_LARGE					2				//
#define	SCALE_STEP_MAX						3				//MAX
#define SCALE_STEP_DEF					SCALE_STEP_SMALL	//l

//Y[xݒ(摜tDBo^ȂǂɎgp)			
#define	ZOOM_LEVEL_18						18				//Y[x18
#define	ZOOM_LEVEL_19						19				//Y[x19
#define	ZOOM_LEVEL_20						20				//Y[x20
#define	ZOOM_LEVEL_21						21				//Y[x21
#define	ZOOM_LEVEL_MIN					ZOOM_LEVEL_18		//MIN
#define	ZOOM_LEVEL_MAX					ZOOM_LEVEL_21		//MAX
#define ZOOM_LEVEL_DEF					ZOOM_LEVEL_18		//l

//Y[x
#define	ZOOM_ADJ_OFF						0				//L[OFF
#define	ZOOM_ADJ_UP							1				//Y[xUp
#define	ZOOM_ADJ_DOWN						2				//Y[xDown
#define	ZOOM_ADJ_MAX						3				//MAX

//n}؂ւ
#define	MAP_KIND_DRONE						0				//h[qʐ^
#define	MAP_KIND_BASIC						1				//n}
#define	MAP_KIND_MAX						2				//MAX
#define MAP_CHENGE_DEF					MAP_KIND_DRONE		//l

//================================================
//	摜tf[^DB
//================================================
// Ww摜tf[^
#define	COORDINATE_DATA_MAX					50				//Ww摜tf[^ől

//Be摜tf[^擾(擾敪)
#define	SHOOTING_IMAGE_ACQ_STOP				0				// STOP l
#define	SHOOTING_IMAGE_ACQ_START			1				// START
#define	SHOOTING_IMAGE_ACQ_UP				2				// UP
#define	SHOOTING_IMAGE_ACQ_DOWN				3				// DOWN

// W(ܓx)
#define	LATITUBE_NIN					20.42527778			// ŏl
#define	LATITUBE_MAX					45.55749972			// ől

// W(ox)	
#define	LONGITUDE_MIN					122.9363889			// ŏl
#define	LONGITUDE_MAX					153.9866664			// ől

// x	
#define	ALTITUDE_NIN						1				// ŏl(m)
#define	ALTITUDE_MAX						110				// ől(m)

// CSV ֘A
#define	CSV_FILE_NAME_LENGH					50				//t@C
#define	CSV_FOLDER_PATH_LENGTH				50				//tH_
#define	CSV_IMAGE_WIDTH_MAX					4000			//摜TCY
#define	CSV_IMAGE_HEIGHT_MAX				3000			//摜TCY
#define	CSV_ROBOT_IDENTIFIER_LENGH			15				//{bgʎq
#define	CSV_CAMERA_NO_MAX					255				//JNO
#define	CSV_ROBOT_DIRECTION_MIN				0				//XijMin
#define	CSV_ROBOT_DIRECTION_MAX				360				//XijMax
#define	CSV_ROBOT_PITCH_MIN					-180			//Xisb`p)Min
#define	CSV_ROBOT_PITCH_MAX					180				//Xisb`p)Max
#define	CSV_ROBOT_ROLL_MIN					-180			//Xi[pjMin
#define	CSV_ROBOT_ROLL_MAX					180				//Xi[pjMax
#define	CSV_SHOOTING_PLAN_NAME_LENGH		15				//Bev於
#define	CSV_FOLDER_EXTENSION				("/*.csv" )		//CSVt@Cgq
#define	CSV_SHOOTING_PLANNAME_LENGTH		30				//Bev於


//摜tf[^JsonL[
#define	IMGADDDB_FILE_NAME				"file_name"			//t@C
#define	IMGADDDB_FOLDER_PATH			"folder_path"		//tH_pX
#define	IMGADDDB_IMAGE_WIDTH			"image_width"		//摜
#define	IMGADDDB_IMAGE_HEIGHT			"image_height"		//摜
#define	IMGADDDB_ROBOT_IDENTIFIER		"robot_identifier"	//{bgʎq
#define	IMGADDDB_CAMERA_NO				"camera_no"			//JNo
#define	IMGADDDB_LATITUDE				"latitude"			//ܓx
#define	IMGADDDB_LONGITUDE				"longitude"			//ox
#define	IMGADDDB_ALTITUDE				"altitude"			//x
#define	IMGADDDB_DIRECTION				"direction"			//p
#define	IMGADDDB_PITCH					"pitch"				//sb`p
#define	IMGADDDB_ROLL					"roll"				//[p
#define	IMGADDDB_SHOOTING_TIME			"shooting_time"		//Be
#define	IMGADDDB_SHOOTING_PLAN_NAME		"shooting_plan_name"//Bev於

//ʒm
#define	ADD_DB_NOTICE_REGIST_SUCCESS			0			//DBo^
#define	ADD_DB_NOTICE_REGIST_ERROR				1			//DBo^s
#define	ADD_DB_NOTICE_SHOOT_LIST_MAKE_SUCCESS 	2			//Bev惊Xg쐬
#define	ADD_DB_NOTICE_SHOOT_LIST_MAKE_ERROR		3			//Bev惊Xg쐬s
#define	ADD_DB_NOTICE_SHOOT_LIST_GET_SUCCESS 	4			//Bev惊Xg擾
#define	ADD_DB_NOTICE_SHOOT_LIST_GET_ERROR		5			//Bev惊Xg擾s
#define	ADD_DB_NOTICE_COORD_GET_SUCCESS			6			//Ww摜tf[^擾
#define	ADD_DB_NOTICE_COORD_GET_ERROR			7			//Ww摜tf[^擾s
#define	ADD_DB_NOTICE_SHOOT_TIME_GET_SUCCESS 	8			//Be摜tf[^擾
#define	ADD_DB_NOTICE_SHOOT_TIME_GET_ERROR		9			//Be摜tf[^擾s
#define	ADD_DB_NOTICE_MAX   					10			//ʒmMAX

//================================================
//	^C
//================================================
//Jsont@C֘A			
#define	MAP_DATA_JSON_FILE_PATH			"c:/workspace/tmp/MapData.Json"		//jsont@CpX

//^C[h(usSetTileGenerateReqMakeTilȇp[^)
#define	TILE_MODE_GENERATE					1				//^C[h
#define	TILE_MODE_SPLIT_DISP_ON				2				//^C\[h
#define	TILE_MODE_SPLIT_DISP_OFF			3				//^C\[h
#define	TILE_MODE_MAX						4				//MAX
#define	TILE_MODE_INIT						0				//l

//ʒm
#define TILEGENE_NOTICE_GENERATE_SUCCESS	0				//^CI
#define TILEGENE_NOTICE_GENERATE_ERROR		1				//^CُI
#define	TILEGENE_NOTICE_MAX					2				//MAX

//================================================
//	n}f[^DB
//================================================
//n}摜tf[^֘A
#define	MAPDATA_TILE_NAME_LENGTH			15				//^C摜t@C̃f[^
#define	MAPDATA_TILE_FOLDER_PATH_LENGTH		90				//tH_pX̃f[^
#define	MAPDATA_PLANNAME_LENGTH		CSV_SHOOTING_PLANNAME_LENGTH	//v於̃f[^

//n}摜tjsonL[֘A
#define	MAPDATA_GROUP_ID				"group_id"			//O[vID
#define	MAPDATA_TILE_BASECODE_X			"tilebasecoord_x"	//^CXW̃L[
#define	MAPDATA_TILE_BASECODE_Y			"tilebasecoord_y"	//^CYW̃L[
#define	MAPDATA_TILE_NUM_X				"tilenum_x"			//X̃^C̃L[
#define	MAPDATA_TILE_NUM_Y				"tilenum_y"			//Ỹ^C̃L[
#define	MAPDATA_KEEP_ZOOM_LEVEL			"keep_zoom"			//ۗLĂY[x̃L[


//n}摜tf[^jsonL[֘A
#define	MAPDATA_TILE_NAME				"tilename"			//^Ĉ̃L[
#define	MAPDATA_FOLDER_PATH				"folderpath"		//tH_[pX̃L[
#define	MAPDATA_ZOOM_LEVEL				"zoomlevel"			//Y[x̃L[
#define	MAPDATA_TILECODE_X				"tilecode_x"		//^CXW̃L[
#define	MAPDATA_TILECODE_Y				"tilecode_y"		//^CYW̃L[
#define	MAPDATA_START_LATITUDE			"startlatitude"		//N_Wܓx̃L[
#define	MAPDATA_START_LONGITUDE			"startlongitude"	//N_Wox̃L[
#define	MAPDATA_END_LATITUDE			"endlatitude"		//I_Wܓx̃L[
#define	MAPDATA_END_LONGITUDE			"endlongitude"		//I_Wox̃L[
#define	MAPDATA_CREATE_DATE				"createdate"		//쐬
#define	MAPDATA_PLAN_NAME				"syntesispalnname"	//v於

//ʒm
#define	MAPDB_REGIST_SUCCESS				0				//n}f[^DBo^I
#define	MAPDB_REGIST_ERROR					1				//n}f[^DBo^ُI
#define	MAPDB_GET_ADD_INFO_SUCCESS			2				//n}摜t̎擾I
#define	MAPDB_GET_ADD_INFO_ERROR			3				//n}摜t̎擾ُI
#define	MAPDB_GET_ADD_DATA_SUCCESS			4				//n}摜tf[^̎擾I
#define	MAPDB_GET_ADD_DATA_ERROR			5				//n}摜tf[^̎擾ُI	
#define	MAPDB_MAKE_LIST_SUCCESS				6				//v惊Xg쐬v
#define	MAPDB_MAKE_LIST_ERROR				7				//v惊Xg쐬vs
#define	MAPDB_GET_LIST_SUCCESS				8				//v惊Xg擾v
#define	MAPDB_GET_LIST_ERROR				9				//v惊Xg擾vs
#define	MAPDB_DEL_LIST_SUCCESS				10				//v惊Xg폜v
#define	MAPDB_DEL_LIST_ERROR				11				//v惊Xg폜vs
#define	MAPDB_NOTICE_MAX					12				//MAX

//================================================
//	n}摜ZNg
//================================================
//n}摜֘A			
#define	MAP_IMAGE_FAILENAME				"MapImage.png"		//^CA݂̒n}摜t@C

//Y[x֘A			
#define MASK_ZOOM_18					0x00000001			//Y[x18p̃}XNl
#define MASK_ZOOM_19					0x00000002			//Y[x19p̃}XNl
#define MASK_ZOOM_20					0x00000004			//Y[x20p̃}XNl
#define MASK_ZOOM_21					0x00000008			//Y[x21p̃}XNl
#define	KEEP_ZOOM_LEVEL_MAX					15				//18A19A20A21ۗL

//ʒm
#define	MAPSEL_NOTICE_SELECT_SUCCESS		0				//n}摜I𐳏I
#define	MAPSEL_NOTICE_SELECT_ERROR			1				//n}摜IُI
#define	MAPSEL_NOTICE_SCROLL_SUCCESS		2				//n}XN[I
#define	MAPSEL_NOTICE_SCROLL_ERROR			3				//n}XN[ُI
#define	MAPSEL_NOTICE_ZOOM_SUCCESS			4				//n}Y[x؂ւI
#define	MAPSEL_NOTICE_ZOOM_ERROR			5				//n}Y[x؂ւُI
#define	MAPSEL_NOTICE_MAPCHG_SUCCESS		6				//n}؂ւI
#define	MAPSEL_NOTICE_MAPCHG_ERROR			7				//n}؂ւُI
#define	MAPSEL_NOTICE_MAX					8				//MAX

//================================================
//	Crawler View摜		
//================================================
//ʒm		
#define	CRAWLER_VIEW_NOTICE_SYNTH_SUCCESS	0				//摜I
#define	CRAWLER_VIEW_NOTICE_SYNTH_ERROR		1				//摜ُI
#define	CRAWLER_VIEW_NOTICE_SLIDE_SUCCESS	2				//XCh؂ւI
#define	CRAWLER_VIEW_NOTICE_SLIDE_ERROR		3				//XCh؂ւُI
#define	CRAWLER_VIEW_NOTICE_MAX				4				//MAX

//================================================
//	Crawler摜ZNg		
//================================================
//ʒm		
#define	CRAWLER_SEL_NOTICE_SELECT_SUCCESS	0				//N[摜I𐳏I
#define	CRAWLER_SEL_NOTICE_SELECT_ERROR		1				//N[摜IُI
#define	CRAWLER_SEL_NOTICE_SLIDE_SUCCESS	2				//XCh؂ւI
#define	CRAWLER_SEL_NOTICE_SLIDE_ERROR		3				//XCh؂ւُI
#define	CRAWLER_SEL_NOTICE_MAX				4				//MAX

